package com.ruoyi.tc.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.tc.entity.*;
import com.ruoyi.tc.entity.request.AssestTaskXqRequest;
import com.ruoyi.tc.entity.request.AssetTaskPageRequest;
import com.ruoyi.tc.entity.response.*;
import com.ruoyi.tc.mapper.AssetTaskMapper;
import com.ruoyi.tc.service.*;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 任务主表(AssetTask)表服务实现类
 *
 * @author makejava
 * @since 2024-11-18 13:23:09
 */
@Service("assetTaskService")
public class AssetTaskServiceImpl extends ServiceImpl<AssetTaskMapper, AssetTask> implements AssetTaskService {
    @Resource
    private AssetTaskMapper assetTaskDao;

    @Resource
    private AssetCurrentCpService assetCurrentCpService;

    @Resource
    private AssetBusinessFormCpService assetBusinessFormCpService;

    @Resource
    private AssetSupplyChainCpService assetSupplyChainCpService;


    @Resource
    private AssetBasicNetworkCpService assetBasicNetworkCpService;


    @Resource
    private UnitOtherConcatCpService unitOtherConcatCpService;




    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public AssetTaskResponse queryById(Integer id) {
        return assetTaskDao.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param assetTask   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<AssetTask> queryByPage(Page<AssetTask> assetTask, AssetTaskPageRequest pageRequest) {
        return assetTaskDao.queryByPage(assetTask, pageRequest);
    }

    /**
     * 新增数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    @Override
    public void insert(AssetTask assetTask) {
        //任务新增
      int id=  assetTaskDao.insert(assetTask);
        String[] parts = assetTask.getDwmc().split(",");
        for (String part : parts) {
            //根据单位名称查询资产
            List<AssetCurrentResponse> list = assetTaskDao.findByDwmcAssetCurrent(part);
         for (AssetCurrentResponse assetCurrentResponse:list){
             assetCurrentResponse.setTaskId(id);
         }
            assetCurrentCpService.saveBatch(list);
            for (AssetCurrentResponse assetCurrentResponse : list) {
                //新增新监管业务形态
                //根据资产id查询新监管业务形态主表id
                List<AssetBusinessFormCpResponse> bussList = assetBusinessFormCpService.findByassetId(assetCurrentResponse.getId());
                if (bussList != null) {
                    for (AssetBusinessFormCpResponse assetBusinessFormCpResponse : bussList) {
                        assetCurrentResponse.getXjgywxt().setId(assetBusinessFormCpResponse.getId());
                        assetCurrentResponse.getXjgywxt().setAssetId(assetCurrentResponse.getId());
                        assetCurrentResponse.getXjgywxt().setTaskId(id);
                        assetBusinessFormCpService.save(assetCurrentResponse.getXjgywxt());
                    }
                }
                //根据资产id查询供应链主表id-
                List<AssetSupplyChainCpResponse> supplyChainList = assetSupplyChainCpService.findByassetId(assetCurrentResponse.getId());
                if (supplyChainList != null) {
                    for (AssetSupplyChainCpResponse items : supplyChainList) {
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setId(items.getId());
                        items.setTaskId(id);
                        //新增供应链
                        assetSupplyChainCpService.save(items);
                    }
                }
                List<AssetBasicNetworkCpResponse> BasicNetworkCpList = assetBasicNetworkCpService.findByassetId(assetCurrentResponse.getId());
                if (BasicNetworkCpList != null) {
                    for (AssetBasicNetworkCpResponse items : BasicNetworkCpList) {
                        //根据资产id查询基础网络主表id
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setId(items.getId());
                        items.setTaskId(id);
                        //新增基础网络
                        assetBasicNetworkCpService.save(items);
                    }

                }
                List<UnitOtherConcatCpResponse> unitOtherConcatList = unitOtherConcatCpService.findByassetId(assetCurrentResponse.getId());
                if (unitOtherConcatList != null) {
                    for (UnitOtherConcatCpResponse items : unitOtherConcatList) {
                        //根据资产id查询其他联系人主表id
                        items.setAssetId(assetCurrentResponse.getId());
                        items.setConcatId(items.getConcatId());
                        items.setTaskId(id);
                        //新增其他联系人
                        unitOtherConcatCpService.save(items);
                    }

                }
            }
        }

    }

    /**
     * 修改数据
     *
     * @param assetTask 实例对象
     * @return 实例对象
     */
    @Override
    public int update(AssetTask assetTask) {
        return this.assetTaskDao.update(assetTask);

    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer id) {
        return this.assetTaskDao.deleteById(id) > 0;
    }

    @Override
    public AssetCurrentResponse taskSh(int taskId,int assetId) {
        AssetCurrentResponse byId = assetTaskDao.findBytaskIdandAssestId(taskId,assetId);
        byId.setGylxxList(assetSupplyChainCpService.lambdaQuery().eq(AssetSupplyChainCpResponse::getAssetId,assetId).eq(AssetSupplyChainCpResponse::getDelFlag,"0").eq(AssetSupplyChainCpResponse::getTaskId,taskId).list());
        byId.setJcwlList(assetBasicNetworkCpService.lambdaQuery().eq(AssetBasicNetworkCpResponse::getAssetId,assetId).eq(AssetBasicNetworkCpResponse::getDelFlag,"0").eq(AssetBasicNetworkCpResponse::getTaskId,taskId).list());
        byId.setXjgywxt(assetBusinessFormCpService.lambdaQuery().eq(AssetBusinessFormCpResponse::getAssetId,assetId).eq(AssetBusinessFormCpResponse::getDelFlag,"0").eq(AssetBusinessFormCpResponse::getTaskId,taskId).one());
        byId.setOtherConcat(unitOtherConcatCpService.lambdaQuery().eq(UnitOtherConcatCpResponse::getAssetId,assetId).eq(UnitOtherConcatCpResponse::getDelFlag,"0").eq(UnitOtherConcatCpResponse::getTaskId,taskId).list());
        return byId;
    }

    @Override
    public Page<AssestTaskXqresponse> zcHc(Page<AssestTaskXqresponse> assetTask, AssestTaskXqRequest pageRequest) {
        return assetTaskDao.zcHc(assetTask,pageRequest);
    }
}
